Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/dataanalysis.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs	(revision 7294)
@@ -21,4 +21,83 @@
 using System;
 
+public partial class alglib
+{
+
+
+    /*************************************************************************
+    Optimal binary classification
+
+    Algorithms finds optimal (=with minimal cross-entropy) binary partition.
+    Internal subroutine.
+
+    INPUT PARAMETERS:
+        A       -   array[0..N-1], variable
+        C       -   array[0..N-1], class numbers (0 or 1).
+        N       -   array size
+
+    OUTPUT PARAMETERS:
+        Info    -   completetion code:
+                    * -3, all values of A[] are same (partition is impossible)
+                    * -2, one of C[] is incorrect (<0, >1)
+                    * -1, incorrect pararemets were passed (N<=0).
+                    *  1, OK
+        Threshold-  partiton boundary. Left part contains values which are
+                    strictly less than Threshold. Right part contains values
+                    which are greater than or equal to Threshold.
+        PAL, PBL-   probabilities P(0|v<Threshold) and P(1|v<Threshold)
+        PAR, PBR-   probabilities P(0|v>=Threshold) and P(1|v>=Threshold)
+        CVE     -   cross-validation estimate of cross-entropy
+
+      -- ALGLIB --
+         Copyright 22.05.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static void dsoptimalsplit2(double[] a, int[] c, int n, out int info, out double threshold, out double pal, out double pbl, out double par, out double pbr, out double cve)
+    {
+        info = 0;
+        threshold = 0;
+        pal = 0;
+        pbl = 0;
+        par = 0;
+        pbr = 0;
+        cve = 0;
+        bdss.dsoptimalsplit2(a, c, n, ref info, ref threshold, ref pal, ref pbl, ref par, ref pbr, ref cve);
+        return;
+    }
+
+    /*************************************************************************
+    Optimal partition, internal subroutine. Fast version.
+
+    Accepts:
+        A       array[0..N-1]       array of attributes     array[0..N-1]
+        C       array[0..N-1]       array of class labels
+        TiesBuf array[0..N]         temporaries (ties)
+        CntBuf  array[0..2*NC-1]    temporaries (counts)
+        Alpha                       centering factor (0<=alpha<=1, recommended value - 0.05)
+        BufR    array[0..N-1]       temporaries
+        BufI    array[0..N-1]       temporaries
+
+    Output:
+        Info    error code (">0"=OK, "<0"=bad)
+        RMS     training set RMS error
+        CVRMS   leave-one-out RMS error
+
+    Note:
+        content of all arrays is changed by subroutine;
+        it doesn't allocate temporaries.
+
+      -- ALGLIB --
+         Copyright 11.12.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static void dsoptimalsplit2fast(ref double[] a, ref int[] c, ref int[] tiesbuf, ref int[] cntbuf, ref double[] bufr, ref int[] bufi, int n, int nc, double alpha, out int info, out double threshold, out double rms, out double cvrms)
+    {
+        info = 0;
+        threshold = 0;
+        rms = 0;
+        cvrms = 0;
+        bdss.dsoptimalsplit2fast(ref a, ref c, ref tiesbuf, ref cntbuf, ref bufr, ref bufi, n, nc, alpha, ref info, ref threshold, ref rms, ref cvrms);
+        return;
+    }
+
+}
 public partial class alglib
 {
@@ -88,4 +167,49 @@
     }
 
+
+    /*************************************************************************
+    This function serializes data structure to string.
+
+    Important properties of s_out:
+    * it contains alphanumeric characters, dots, underscores, minus signs
+    * these symbols are grouped into words, which are separated by spaces
+      and Windows-style (CR+LF) newlines
+    * although  serializer  uses  spaces and CR+LF as separators, you can 
+      replace any separator character by arbitrary combination of spaces,
+      tabs, Windows or Unix newlines. It allows flexible reformatting  of
+      the  string  in  case you want to include it into text or XML file. 
+      But you should not insert separators into the middle of the "words"
+      nor you should change case of letters.
+    * s_out can be freely moved between 32-bit and 64-bit systems, little
+      and big endian machines, and so on. You can serialize structure  on
+      32-bit machine and unserialize it on 64-bit one (or vice versa), or
+      serialize  it  on  SPARC  and  unserialize  on  x86.  You  can also 
+      serialize  it  in  C# version of ALGLIB and unserialize in C++ one, 
+      and vice versa.
+    *************************************************************************/
+    public static void dfserialize(decisionforest obj, out string s_out)
+    {
+        alglib.serializer s = new alglib.serializer();
+        s.alloc_start();
+        dforest.dfalloc(s, obj.innerobj);
+        s.sstart_str();
+        dforest.dfserialize(s, obj.innerobj);
+        s.stop();
+        s_out = s.get_string();
+    }
+
+
+    /*************************************************************************
+    This function unserializes data structure from string.
+    *************************************************************************/
+    public static void dfunserialize(string s_in, out decisionforest obj)
+    {
+        alglib.serializer s = new alglib.serializer();
+        obj = new decisionforest();
+        s.ustart_str(s_in);
+        dforest.dfunserialize(s, obj.innerobj);
+        s.stop();
+    }
+
     /*************************************************************************
     This subroutine builds random decision forest.
@@ -131,4 +255,49 @@
 
     /*************************************************************************
+    This subroutine builds random decision forest.
+    This function gives ability to tune number of variables used when choosing
+    best split.
+
+    INPUT PARAMETERS:
+        XY          -   training set
+        NPoints     -   training set size, NPoints>=1
+        NVars       -   number of independent variables, NVars>=1
+        NClasses    -   task type:
+                        * NClasses=1 - regression task with one
+                                       dependent variable
+                        * NClasses>1 - classification task with
+                                       NClasses classes.
+        NTrees      -   number of trees in a forest, NTrees>=1.
+                        recommended values: 50-100.
+        NRndVars    -   number of variables used when choosing best split
+        R           -   percent of a training set used to build
+                        individual trees. 0<R<=1.
+                        recommended values: 0.1 <= R <= 0.66.
+
+    OUTPUT PARAMETERS:
+        Info        -   return code:
+                        * -2, if there is a point with class number
+                              outside of [0..NClasses-1].
+                        * -1, if incorrect parameters was passed
+                              (NPoints<1, NVars<1, NClasses<1, NTrees<1, R<=0
+                              or R>1).
+                        *  1, if task has been solved
+        DF          -   model built
+        Rep         -   training report, contains error on a training set
+                        and out-of-bag estimates of generalization error.
+
+      -- ALGLIB --
+         Copyright 19.02.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static void dfbuildrandomdecisionforestx1(double[,] xy, int npoints, int nvars, int nclasses, int ntrees, int nrndvars, double r, out int info, out decisionforest df, out dfreport rep)
+    {
+        info = 0;
+        df = new decisionforest();
+        rep = new dfreport();
+        dforest.dfbuildrandomdecisionforestx1(xy, npoints, nvars, nclasses, ntrees, nrndvars, r, ref info, df.innerobj, rep.innerobj);
+        return;
+    }
+
+    /*************************************************************************
     Procesing
 
@@ -291,83 +460,4 @@
 
     /*************************************************************************
-    Optimal binary classification
-
-    Algorithms finds optimal (=with minimal cross-entropy) binary partition.
-    Internal subroutine.
-
-    INPUT PARAMETERS:
-        A       -   array[0..N-1], variable
-        C       -   array[0..N-1], class numbers (0 or 1).
-        N       -   array size
-
-    OUTPUT PARAMETERS:
-        Info    -   completetion code:
-                    * -3, all values of A[] are same (partition is impossible)
-                    * -2, one of C[] is incorrect (<0, >1)
-                    * -1, incorrect pararemets were passed (N<=0).
-                    *  1, OK
-        Threshold-  partiton boundary. Left part contains values which are
-                    strictly less than Threshold. Right part contains values
-                    which are greater than or equal to Threshold.
-        PAL, PBL-   probabilities P(0|v<Threshold) and P(1|v<Threshold)
-        PAR, PBR-   probabilities P(0|v>=Threshold) and P(1|v>=Threshold)
-        CVE     -   cross-validation estimate of cross-entropy
-
-      -- ALGLIB --
-         Copyright 22.05.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static void dsoptimalsplit2(double[] a, int[] c, int n, out int info, out double threshold, out double pal, out double pbl, out double par, out double pbr, out double cve)
-    {
-        info = 0;
-        threshold = 0;
-        pal = 0;
-        pbl = 0;
-        par = 0;
-        pbr = 0;
-        cve = 0;
-        bdss.dsoptimalsplit2(a, c, n, ref info, ref threshold, ref pal, ref pbl, ref par, ref pbr, ref cve);
-        return;
-    }
-
-    /*************************************************************************
-    Optimal partition, internal subroutine. Fast version.
-
-    Accepts:
-        A       array[0..N-1]       array of attributes     array[0..N-1]
-        C       array[0..N-1]       array of class labels
-        TiesBuf array[0..N]         temporaries (ties)
-        CntBuf  array[0..2*NC-1]    temporaries (counts)
-        Alpha                       centering factor (0<=alpha<=1, recommended value - 0.05)
-        BufR    array[0..N-1]       temporaries
-        BufI    array[0..N-1]       temporaries
-
-    Output:
-        Info    error code (">0"=OK, "<0"=bad)
-        RMS     training set RMS error
-        CVRMS   leave-one-out RMS error
-
-    Note:
-        content of all arrays is changed by subroutine;
-        it doesn't allocate temporaries.
-
-      -- ALGLIB --
-         Copyright 11.12.2008 by Bochkanov Sergey
-    *************************************************************************/
-    public static void dsoptimalsplit2fast(ref double[] a, ref int[] c, ref int[] tiesbuf, ref int[] cntbuf, ref double[] bufr, ref int[] bufi, int n, int nc, double alpha, out int info, out double threshold, out double rms, out double cvrms)
-    {
-        info = 0;
-        threshold = 0;
-        rms = 0;
-        cvrms = 0;
-        bdss.dsoptimalsplit2fast(ref a, ref c, ref tiesbuf, ref cntbuf, ref bufr, ref bufi, n, nc, alpha, ref info, ref threshold, ref rms, ref cvrms);
-        return;
-    }
-
-}
-public partial class alglib
-{
-
-
-    /*************************************************************************
     k-means++ clusterization
 
@@ -387,6 +477,5 @@
         C           -   array[0..NVars-1,0..K-1].matrix whose columns store
                         cluster's centers
-        XYC         -   array which contains number of clusters dataset points
-                        belong to.
+        XYC         -   array[NPoints], which contains cluster indexes
 
       -- ALGLIB --
@@ -701,4 +790,5 @@
     OUTPUT PARAMETERS:
         V           -   coefficients, array[0..NVars]
+                        constant term (intercept) is stored in the V[NVars].
         NVars       -   number of independent variables (one less than number
                         of coefficients)
